package org.silverpeas.mobile.shared.services.rest;

import static org.fusesource.restygwt.client.AbstractJsonEncoderDecoder.*;

public class ServiceConnection_Generated_RestServiceProxy_ implements org.silverpeas.mobile.shared.services.rest.ServiceConnection, org.fusesource.restygwt.client.RestServiceProxy {
  private org.fusesource.restygwt.client.Resource resource = null;
  
  public void setResource(org.fusesource.restygwt.client.Resource resource) {
    this.resource = resource;
  }
  public org.fusesource.restygwt.client.Resource getResource() {
    if (this.resource == null) {
      String serviceRoot = org.fusesource.restygwt.client.Defaults.getServiceRoot();
      this.resource = new org.fusesource.restygwt.client.Resource(serviceRoot).resolve("/mobile/connection");
    }
    return this.resource;
  }
  private org.fusesource.restygwt.client.Dispatcher dispatcher = null;
  
  public void setDispatcher(org.fusesource.restygwt.client.Dispatcher dispatcher) {
    this.dispatcher = dispatcher;
  }
  
  public org.fusesource.restygwt.client.Dispatcher getDispatcher() {
    return this.dispatcher;
  }
  public void changePwd(java.lang.String newPwd, org.fusesource.restygwt.client.MethodCallback<java.lang.Void> callback) {
    final java.lang.String final_newPwd = newPwd;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve("changePwd/")
    .put();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, "application/json");
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_CONTENT_TYPE, "application/json");
    __method.text(newPwd);
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<java.lang.Void>(__method, callback) {
        protected java.lang.Void parseResult() throws Exception {
          return (java.lang.Void) null;
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void checkSecurityCode(java.lang.String login, java.lang.String domainId, java.lang.String code, org.fusesource.restygwt.client.MethodCallback<java.lang.Boolean> callback) {
    final java.lang.String final_login = login;
    final java.lang.String final_domainId = domainId;
    final java.lang.String final_code = code;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve("securityCode/check/"+(login== null? null : com.google.gwt.http.client.URL.encodePathSegment(login))+"/"+(domainId== null? null : com.google.gwt.http.client.URL.encodePathSegment(domainId))+"/"+(code== null? null : com.google.gwt.http.client.URL.encodePathSegment(code))+"")
    .get();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, "application/json");
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<java.lang.Boolean>(__method, callback) {
        protected java.lang.Boolean parseResult() throws Exception {
          try {
            return BOOLEAN.decode(com.google.gwt.json.client.JSONParser.parse(__method.getResponse().getText()));
          } catch (Throwable __e) {
            throw new org.fusesource.restygwt.client.ResponseFormatException("Response was NOT a valid JSON document", __e);
          }
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void generateSecurityCode(java.lang.String login, java.lang.String domainId, org.fusesource.restygwt.client.MethodCallback<java.lang.Void> callback) {
    final java.lang.String final_login = login;
    final java.lang.String final_domainId = domainId;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve("securityCode/"+(login== null? null : com.google.gwt.http.client.URL.encodePathSegment(login))+"/"+(domainId== null? null : com.google.gwt.http.client.URL.encodePathSegment(domainId))+"")
    .get();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, "application/json");
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<java.lang.Void>(__method, callback) {
        protected java.lang.Void parseResult() throws Exception {
          return (java.lang.Void) null;
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void getDomains(org.fusesource.restygwt.client.MethodCallback<java.util.List<org.silverpeas.mobile.shared.dto.DomainDTO>> callback) {
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve("domains/")
    .get();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, "application/json");
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<java.util.List<org.silverpeas.mobile.shared.dto.DomainDTO>>(__method, callback) {
        protected java.util.List<org.silverpeas.mobile.shared.dto.DomainDTO> parseResult() throws Exception {
          try {
            return toList(com.google.gwt.json.client.JSONParser.parse(__method.getResponse().getText()), org.silverpeas.mobile.shared.dto.DomainDTO_Generated_JsonEncoderDecoder_.INSTANCE);
          } catch (Throwable __e) {
            throw new org.fusesource.restygwt.client.ResponseFormatException("Response was NOT a valid JSON document", __e);
          }
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void login(java.util.List<java.lang.String> ids, org.fusesource.restygwt.client.MethodCallback<org.silverpeas.mobile.shared.dto.DetailUserDTO> callback) {
    final java.util.List<java.lang.String> final_ids = ids;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve("login")
    .post();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, "application/json");
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_CONTENT_TYPE, "application/json");
    __method.json(toJSON(ids, STRING));
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<org.silverpeas.mobile.shared.dto.DetailUserDTO>(__method, callback) {
        protected org.silverpeas.mobile.shared.dto.DetailUserDTO parseResult() throws Exception {
          try {
            return org.silverpeas.mobile.shared.dto.DetailUserDTO_Generated_JsonEncoderDecoder_.INSTANCE.decode(com.google.gwt.json.client.JSONParser.parse(__method.getResponse().getText()));
          } catch (Throwable __e) {
            throw new org.fusesource.restygwt.client.ResponseFormatException("Response was NOT a valid JSON document", __e);
          }
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void setTabletMode(org.fusesource.restygwt.client.MethodCallback<java.lang.Boolean> callback) {
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve("setTabletMode/")
    .put();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, "application/json");
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<java.lang.Boolean>(__method, callback) {
        protected java.lang.Boolean parseResult() throws Exception {
          try {
            return BOOLEAN.decode(com.google.gwt.json.client.JSONParser.parse(__method.getResponse().getText()));
          } catch (Throwable __e) {
            throw new org.fusesource.restygwt.client.ResponseFormatException("Response was NOT a valid JSON document", __e);
          }
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void userAcceptsTermsOfService(org.fusesource.restygwt.client.MethodCallback<java.lang.Void> callback) {
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve("userAcceptsTermsOfService/")
    .put();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, "application/json");
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<java.lang.Void>(__method, callback) {
        protected java.lang.Void parseResult() throws Exception {
          return (java.lang.Void) null;
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void userExist(java.lang.String login, java.lang.String domainId, org.fusesource.restygwt.client.MethodCallback<java.lang.Boolean> callback) {
    final java.lang.String final_login = login;
    final java.lang.String final_domainId = domainId;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve("userExist/"+(login== null? null : com.google.gwt.http.client.URL.encodePathSegment(login))+"/"+(domainId== null? null : com.google.gwt.http.client.URL.encodePathSegment(domainId))+"")
    .get();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, "application/json");
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<java.lang.Boolean>(__method, callback) {
        protected java.lang.Boolean parseResult() throws Exception {
          try {
            return BOOLEAN.decode(com.google.gwt.json.client.JSONParser.parse(__method.getResponse().getText()));
          } catch (Throwable __e) {
            throw new org.fusesource.restygwt.client.ResponseFormatException("Response was NOT a valid JSON document", __e);
          }
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
}
